<script lang="ts">
  import HeaderWithBackdrop from '$lib/components/ui-elements/HeaderWithBackdrop.svelte';
  import Alert from '$lib/components/ui-elements/Alert.svelte';
  import { discoverableTeams } from '$routes/(app)/user-dashboard/stores';
  import type { DiscoverTeamsSub$result } from '$houdini';
  import type { Team } from '$lib/graphql/types';
  import ExistingTeamCard from '$lib/components/ui-elements/ExistingTeamCard.svelte';

  export let displayNoTeamsWarning = false;
  // show teams where every event has not started
  $: teams = ($discoverableTeams.data?.teams || []).filter((t) => t.events?.every((e) => !e.event.ended));

  function castTeam(t: DiscoverTeamsSub$result['teams'][0]): Team {
    // @ts-ignore recast team as the expected data type
    return t as Team;
  }
</script>

{#if (!teams || teams.length === 0) && displayNoTeamsWarning}
  <Alert color="green" class="mb-3">
    <div slot="title">No Teams Exist</div>
    Looks like no teams exist yet! Team Captains, go
    <a href="/user-dashboard/teams/create">create one</a>!
  </Alert>
{:else if teams && teams.length > 0}
  <section class="w-full pt-4">
    <HeaderWithBackdrop size="sm" secondary wrap>Discover Existing Teams</HeaderWithBackdrop>
    <p class="max-md:pt-4">
      These Teams already exist at <i>your Institution</i>. Interested in joining one? Contact the team captain today!
    </p>
    {#each teams as team}
      <div class="my-5">
        <ExistingTeamCard team={castTeam(team)} hideControls />
      </div>
    {/each}
  </section>
{/if}
